Index: squid/src/store.c
diff -u squid/src/store.c:1.1.1.2 squid/src/store.c:1.1.1.2.10.1
--- squid/src/store.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/store.c	Fri Nov 10 10:44:52 2000
@@ -982,15 +1333,28 @@
 {
     if (storeEntryLocked(e))
 	return 0;
-    if (EBIT_TEST(e->flags, RELEASE_REQUEST))
+    if (EBIT_TEST(e->Sflag, RELEASE_REQUEST))
 	return 1;
-    if (EBIT_TEST(e->flags, ENTRY_NEGCACHED) && squid_curtime >= e->expires)
+    if (EBIT_TEST(e->Sflag, ENTRY_NEGCACHED) && squid_curtime >= e->Sexpires)
 	return 1;
-    if (squid_curtime - e->lastref > storeExpiredReferenceAge())
+#ifdef	HPL_REPL
+    /*
+     * With HPL_REPL we are not using the LRU reference age, the heap
+     * controls the replacement of objects.
+     */
+    return 1;
+#else	/* HPL_REPL */
+    if (squid_curtime - e->Slastref > storeExpiredReferenceAge())
 	return 1;
     return 0;
+#endif	/* HPL_REPL */
 }
 
+#ifdef	HPL_REPL
+/*
+ * The non-LRU cache replacement policies do not use LRU referenceAge
+ */
+#else	/* HPL_REPL */
 /* 
  * storeExpiredReferenceAge
  *
@@ -1018,12 +1382,13 @@
 	age = 31536000;
     return age;
 }
+#endif	/* HPL_REPL */
 
 void
 storeNegativeCache(StoreEntry * e)
 {
-    e->expires = squid_curtime + Config.negativeTtl;
-    EBIT_SET(e->flags, ENTRY_NEGCACHED);
+    e->Sexpires = squid_curtime + Config.negativeTtl;
+    EBIT_SET(e->Sflag, ENTRY_NEGCACHED);
 }
 
 void
@@ -1050,12 +1415,12 @@
 int
 storeEntryValidToSend(StoreEntry * e)
 {
-    if (EBIT_TEST(e->flags, RELEASE_REQUEST))
+    if (EBIT_TEST(e->Sflag, RELEASE_REQUEST))
 	return 0;
-    if (EBIT_TEST(e->flags, ENTRY_NEGCACHED))
-	if (e->expires <= squid_curtime)
+    if (EBIT_TEST(e->Sflag, ENTRY_NEGCACHED))
+	if (e->Sexpires <= squid_curtime)
 	    return 0;
-    if (EBIT_TEST(e->flags, ENTRY_ABORTED))
+    if (EBIT_TEST(e->Sflag, ENTRY_ABORTED))
 	return 0;
     return 1;
 }
@@ -1068,9 +1433,9 @@
     served_date = reply->date;
     if (served_date < 0)
 	served_date = squid_curtime;
-    entry->expires = reply->expires;
-    entry->lastmod = reply->last_modified;
-    entry->timestamp = served_date;
+    entry->Sexpires = reply->expires;
+    entry->Slastmod = reply->last_modified;
+    entry->Stimestamp = served_date;
 }
 
 void
@@ -1125,17 +1490,16 @@
 void
 storeEntryDump(StoreEntry * e, int l)
 {
-    debug(20, l) ("StoreEntry->key: %s\n", storeKeyText(e->key));
-    debug(20, l) ("StoreEntry->next: %p\n", e->next);
+    debug(20, l) ("StoreEntry->key: %s\n", storeKeyText(e->Skey));
     debug(20, l) ("StoreEntry->mem_obj: %p\n", e->mem_obj);
-    debug(20, l) ("StoreEntry->timestamp: %d\n", (int) e->timestamp);
-    debug(20, l) ("StoreEntry->lastref: %d\n", (int) e->lastref);
-    debug(20, l) ("StoreEntry->expires: %d\n", (int) e->expires);
-    debug(20, l) ("StoreEntry->lastmod: %d\n", (int) e->lastmod);
-    debug(20, l) ("StoreEntry->swap_file_sz: %d\n", (int) e->swap_file_sz);
-    debug(20, l) ("StoreEntry->refcount: %d\n", e->refcount);
-    debug(20, l) ("StoreEntry->flags: %s\n", storeEntryFlags(e));
-    debug(20, l) ("StoreEntry->swap_file_number: %d\n", (int) e->swap_file_number);
+    debug(20, l) ("StoreEntry->Stimestamp: %d\n", (int) e->Stimestamp);
+    debug(20, l) ("StoreEntry->Slastref: %d\n", (int) e->Slastref);
+    debug(20, l) ("StoreEntry->Sexpires: %d\n", (int) e->Sexpires);
+    debug(20, l) ("StoreEntry->Slastmod: %d\n", (int) e->Slastmod);
+    debug(20, l) ("StoreEntry->Sswap_file_sz: %d\n", (int) e->Sswap_file_sz);
+    debug(20, l) ("StoreEntry->Srefcount: %d\n", e->Srefcount);
+    debug(20, l) ("StoreEntry->flag: %X %s\n", e->Sflag, storeEntryFlags(e));
+    debug(20, l) ("StoreEntry->Sswap_file_number: %d\n", (int) e->Sswap_file_number);
     debug(20, l) ("StoreEntry->lock_count: %d\n", (int) e->lock_count);
     debug(20, l) ("StoreEntry->mem_status: %d\n", (int) e->mem_status);
     debug(20, l) ("StoreEntry->ping_status: %d\n", (int) e->ping_status);
@@ -1153,10 +1517,33 @@
     assert(mem != NULL);
     if (new_status == IN_MEMORY) {
 	assert(mem->inmem_lo == 0);
+	#ifdef	HPL_REPL
+	if (mem->n.ode.id < 0) {
+	  if (EBIT_TEST(e->Sflag, ENTRY_SPECIAL)) {
+	    debug(20, 4) ("storeSetMemStatus: not inserting special %s\n", mem->url);
+	  } else {
+	    heap_insert(inmem_heap, mem);
+	    debug(20, 4) ("storeSetMemStatus: inserted mem node %d\n", mem->n.ode.id);
+	  }
+	}
+	#else	/* HPL_REPL */
 	dlinkAdd(e, &mem->lru, &inmem_list);
+	#endif	/* HPL_REPL */
 	hot_obj_count++;
     } else {
+      #ifdef	HPL_REPL
+      /*
+       * It's being removed from the memory heap; is it already gone?
+       */
+      if (mem->n.ode.id >= 0) {
+	heap_delete(inmem_heap, &mem->n.ode);
+	debug(20, 4) ("storeSetMemStatus: deleted mem node %d\n",
+		      mem->n.ode.id);
+	mem->n.ode.id = -1;
+      }
+      #else	/* HPL_REPL */
 	dlinkDelete(&mem->lru, &inmem_list);
+      #endif	/* HPL_REPL */
 	hot_obj_count--;
     }
     e->mem_status = new_status;
@@ -1179,20 +1566,23 @@
     if (e->mem_obj)
 	return;
     e->mem_obj = new_MemObject(url, log_url);
+#if HPL_REPL
+    e->mem_obj->entry = e;
+#endif
 }
 
 /* this just sets DELAY_SENDING */
 void
 storeBuffer(StoreEntry * e)
 {
-    EBIT_SET(e->flags, DELAY_SENDING);
+    EBIT_SET(e->Sflag, DELAY_SENDING);
 }
 
 /* this just clears DELAY_SENDING and Invokes the handlers */
 void
 storeBufferFlush(StoreEntry * e)
 {
-    EBIT_CLR(e->flags, DELAY_SENDING);
+    EBIT_CLR(e->Sflag, DELAY_SENDING);
     InvokeHandlers(e);
     storeCheckSwapOut(e);
 }
@@ -1200,7 +1590,7 @@
 void
 storeUnlinkFileno(int fileno)
 {
-    debug(20, 5) ("storeUnlinkFileno: %08X\n", fileno);
+    debug(20, 6) ("storeUnlinkFileno: %08X\n", fileno);
 #if USE_ASYNC_IO
     safeunlink(storeSwapFullPath(fileno, NULL), 1);
 #else
@@ -1237,7 +1627,7 @@
 storeEntryReset(StoreEntry * e)
 {
     MemObject *mem = e->mem_obj;
-    debug(20, 3) ("storeEntryReset: %s\n", storeUrl(e));
+    debug(20, 4) ("storeEntryReset: %s\n", storeUrl(e));
     assert(mem->swapout.fd == -1);
     stmemFree(&mem->data_hdr);
     mem->inmem_hi = mem->inmem_lo = 0;
Index: squid/src/store_client.c
diff -u squid/src/store_client.c:1.1.1.2 squid/src/store_client.c:1.1.1.2.10.1
--- squid/src/store_client.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/store_client.c	Fri Nov 10 10:44:52 2000
@@ -81,7 +81,7 @@
     MemObject *mem = e->mem_obj;
     if (mem->inmem_lo)
 	return STORE_DISK_CLIENT;
-    if (EBIT_TEST(e->flags, ENTRY_ABORTED)) {
+    if (EBIT_TEST(e->Sflag, ENTRY_ABORTED)) {
 	/* I don't think we should be adding clients to aborted entries */
 	debug(20, 1) ("storeClientType: adding to ENTRY_ABORTED entry\n");
 	return STORE_MEM_CLIENT;
@@ -129,7 +129,7 @@
     if (sc->type == STORE_DISK_CLIENT)
 	/* assert we'll be able to get the data we want */
 	/* maybe we should open swapin_fd here */
-	assert(e->swap_file_number > -1 || storeSwapOutAble(e));
+	assert(e->Sswap_file_number > -1 || storeSwapOutAble(e));
     for (T = &mem->clients; *T; T = &(*T)->next);
     *T = sc;
 #if DELAY_POOLS
@@ -141,7 +141,7 @@
 storeClientCopyEvent(void *data)
 {
     store_client *sc = data;
-    debug(20, 3) ("storeClientCopyEvent: Running\n");
+    debug(20, 4) ("storeClientCopyEvent: Running\n");
     sc->flags.copy_event_pending = 0;
     if (!sc->callback)
 	return;
@@ -159,9 +159,9 @@
     void *data)
 {
     store_client *sc;
-    assert(!EBIT_TEST(e->flags, ENTRY_ABORTED));
+    assert(!EBIT_TEST(e->Sflag, ENTRY_ABORTED));
     debug(20, 3) ("storeClientCopy: %s, seen %d, want %d, size %d, cb %p, cbdata %p\n",
-	storeKeyText(e->key),
+	storeKeyText(e->Skey),
 	(int) seen_offset,
 	(int) copy_offset,
 	(int) size,
@@ -209,7 +209,7 @@
     size_t sz;
     if (sc->flags.copy_event_pending)
 	return;
-    if (EBIT_TEST(e->flags, ENTRY_FWD_HDR_WAIT)) {
+    if (EBIT_TEST(e->Sflag, ENTRY_FWD_HDR_WAIT)) {
 	debug(20, 5) ("storeClientCopy2: returning because ENTRY_FWD_HDR_WAIT set\n");
 	return;
     }
@@ -221,7 +221,7 @@
     }
     cbdataLock(sc);		/* ick, prevent sc from getting freed */
     sc->flags.store_copying = 1;
-    debug(20, 3) ("storeClientCopy2: %s\n", storeKeyText(e->key));
+    debug(20, 3) ("storeClientCopy2: %s\n", storeKeyText(e->Skey));
     assert(callback != NULL);
     /*
      * We used to check for ENTRY_ABORTED here.  But there were some
@@ -245,10 +245,10 @@
 	callback(sc->callback_data, sc->copy_buf, 0);
     } else if (e->store_status == STORE_PENDING && sc->seen_offset >= mem->inmem_hi) {
 	/* client has already seen this, wait for more */
-	debug(20, 3) ("storeClientCopy2: Waiting for more\n");
+	debug(20, 4) ("storeClientCopy2: Waiting for more\n");
     } else if (sc->copy_offset >= mem->inmem_lo && sc->copy_offset < mem->inmem_hi) {
 	/* What the client wants is in memory */
-	debug(20, 3) ("storeClientCopy2: Copying from memory\n");
+	debug(20, 4) ("storeClientCopy2: Copying from memory\n");
 	sz = stmemCopy(&mem->data_hdr, sc->copy_offset, sc->copy_buf, sc->copy_size);
 #if USE_ASYNC_IO
 	if (sc->flags.disk_io_pending) {
@@ -262,7 +262,7 @@
 	sc->callback = NULL;
 	callback(sc->callback_data, sc->copy_buf, sz);
     } else if (sc->swapin_fd < 0) {
-	debug(20, 3) ("storeClientCopy2: Need to open swap in file\n");
+	debug(20, 4) ("storeClientCopy2: Need to open swap in file\n");
 	assert(sc->type == STORE_DISK_CLIENT);
 	/* gotta open the swapin file */
 	if (storeTooManyDiskFilesOpen()) {
@@ -276,7 +276,7 @@
 	    debug(20, 2) ("storeClientCopy2: Averted multiple fd operation\n");
 	}
     } else {
-	debug(20, 3) ("storeClientCopy: reading from disk FD %d\n",
+	debug(20, 4) ("storeClientCopy: reading from disk FD %d\n",
 	    sc->swapin_fd);
 	assert(sc->type == STORE_DISK_CLIENT);
 	if (!sc->flags.disk_io_pending) {
@@ -295,7 +295,7 @@
     store_client *sc = data;
     STCB *callback = sc->callback;
     if (fd < 0) {
-	debug(20, 3) ("storeClientFileOpened: failed\n");
+	debug(20, 4) ("storeClientFileOpened: failed\n");
 	sc->flags.disk_io_pending = 0;
 	sc->callback = NULL;
 	callback(sc->callback_data, sc->copy_buf, -1);
@@ -344,7 +344,7 @@
     assert(sc->flags.disk_io_pending);
     sc->flags.disk_io_pending = 0;
     assert(sc->callback != NULL);
-    debug(20, 3) ("storeClientReadBody: FD %d, len %d\n", fd, len);
+    debug(20, 4) ("storeClientReadBody: FD %d, len %d\n", fd, len);
     if (sc->copy_offset == 0 && len > 0 && mem->reply->sline.status == 0)
 	httpReplyParse(mem->reply, sc->copy_buf);
     sc->callback = NULL;
@@ -365,9 +365,9 @@
     assert(sc->flags.disk_io_pending);
     sc->flags.disk_io_pending = 0;
     assert(sc->callback != NULL);
-    debug(20, 3) ("storeClientReadHeader: FD %d, len %d\n", fd, len);
+    debug(20, 4) ("storeClientReadHeader: FD %d, len %d\n", fd, len);
     if (len < 0) {
-	debug(20, 3) ("storeClientReadHeader: FD %d: %s\n", fd, xstrerror());
+	debug(20, 4) ("storeClientReadHeader: FD %d: %s\n", fd, xstrerror());
 	sc->callback = NULL;
 	callback(sc->callback_data, sc->copy_buf, len);
 	return;
@@ -380,12 +380,44 @@
 	return;
     }
     /*
-     * XXX Here we should check the meta data and make sure we got
+     * Check the meta data and make sure we got
      * the right object.
      */
+    {
+	tlv *tlv_cur;
+	char *skey = 0;
+	for (tlv_cur = tlv_list; tlv_cur; tlv_cur = tlv_cur->next)
+	    switch (tlv_cur->type)
+	    {
+		case STORE_META_KEY:
+		    if (memcmp(e->Skey, skey = (char*)tlv_cur->value, MD5_DIGEST_CHARS))
+		    {
+			debug(20, 0) ("storeClientReadHeader: MD5 mismatch %x %s\n",
+			    e->Sswap_file_number, storeUrl(e));
+badstore:		debug(20, 0) ("storeClientReadHeader: MD5 match? %x %s %s\n",
+			    e->Sswap_file_number,
+			    skey ? storeKeyText(skey) : "-", storeKeyText(e->Skey));
+			storeSwapTLVFree(tlv_list);
+			sc->callback = NULL;
+			callback(sc->callback_data, sc->copy_buf, -1);
+			return;
+		    }
+#if 0				/* optimisation possible */
+		    tlv_cur = 0;
+#endif
+		    break;
+		case STORE_META_URL:
+		    if (memcmp((char*)tlv_cur->value, storeUrl(e), tlv_cur->length))
+		    {
+			debug(20, 0) ("storeClientReadHeader: URL mismatch %x %s %s\n",
+			    e->Sswap_file_number, (char*)tlv_cur->value, storeUrl(e));
+			goto badstore;
+		    }
+	    }
+    }
     storeSwapTLVFree(tlv_list);
     mem->swap_hdr_sz = swap_hdr_sz;
-    mem->object_sz = e->swap_file_sz - swap_hdr_sz;
+    mem->object_sz = e->Sswap_file_sz - swap_hdr_sz;
     /*
      * If our last read got some data the client wants, then give
      * it to them, otherwise schedule another read.
@@ -396,7 +428,7 @@
 	 * we have (part of) what they want
 	 */
 	copy_sz = XMIN(sc->copy_size, body_sz);
-	debug(20, 3) ("storeClientReadHeader: copying %d bytes of body\n",
+	debug(20, 4) ("storeClientReadHeader: copying %d bytes of body\n",
 	    copy_sz);
 	xmemmove(sc->copy_buf, sc->copy_buf + swap_hdr_sz, copy_sz);
 	if (sc->copy_offset == 0 && len > 0 && mem->reply->sline.status == 0)
@@ -433,7 +465,7 @@
     STCB *callback;
     if (mem == NULL)
 	return 0;
-    debug(20, 3) ("storeUnregister: called for '%s'\n", storeKeyText(e->key));
+    debug(20, 3) ("storeUnregister: called for '%s'\n", storeKeyText(e->Skey));
     for (S = &mem->clients; (sc = *S) != NULL; S = &(*S)->next) {
 	if (sc->callback_data == data)
 	    break;
@@ -462,7 +494,7 @@
 #endif
     if ((callback = sc->callback) != NULL) {
 	/* callback with ssize = -1 to indicate unexpected termination */
-	debug(20, 3) ("storeUnregister: store_client for %s has a callback\n",
+	debug(20, 4) ("storeUnregister: store_client for %s has a callback\n",
 	    mem->url);
 	sc->callback = NULL;
 	callback(sc->callback_data, sc->copy_buf, -1);
@@ -505,7 +537,7 @@
     store_client *sc;
     store_client *nx = NULL;
     assert(mem->clients != NULL || mem->nclients == 0);
-    debug(20, 3) ("InvokeHandlers: %s\n", storeKeyText(e->key));
+    debug(20, 3) ("InvokeHandlers: %s\n", storeKeyText(e->Skey));
     /* walk the entire list looking for valid callbacks */
     for (sc = mem->clients; sc; sc = nx) {
 	nx = sc->next;
@@ -523,7 +555,7 @@
 {
     MemObject *mem = e->mem_obj;
     int npend = NULL == mem ? 0 : mem->nclients;
-    debug(20, 3) ("storePendingNClients: returning %d\n", npend);
+    debug(20, 4) ("storePendingNClients: returning %d\n", npend);
     return npend;
 }
 
@@ -541,7 +573,7 @@
 	debug(20, 3) ("CheckQuickAbort2: YES !mem->request->flags.cachable\n");
 	return 1;
     }
-    if (EBIT_TEST(entry->flags, KEY_PRIVATE)) {
+    if (EBIT_TEST(entry->Sflag, KEY_PRIVATE)) {
 	debug(20, 3) ("CheckQuickAbort2: YES KEY_PRIVATE\n");
 	return 1;
     }
@@ -585,7 +617,7 @@
 	return;
     if (entry->store_status != STORE_PENDING)
 	return;
-    if (EBIT_TEST(entry->flags, ENTRY_SPECIAL))
+    if (EBIT_TEST(entry->Sflag, ENTRY_SPECIAL))
 	return;
     if (CheckQuickAbort2(entry) == 0)
 	return;
Index: squid/src/store_digest.c
diff -u squid/src/store_digest.c:1.1.1.2 squid/src/store_digest.c:1.1.1.2.12.1
--- squid/src/store_digest.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/store_digest.c	Fri Nov 10 10:44:53 2000
@@ -138,17 +138,17 @@
 #if USE_CACHE_DIGESTS
     assert(entry && store_digest);
     debug(71, 6) ("storeDigestDel: checking entry, key: %s\n",
-	storeKeyText(entry->key));
-    if (!EBIT_TEST(entry->flags, KEY_PRIVATE)) {
-	if (!cacheDigestTest(store_digest, entry->key)) {
+	storeKeyText(entry->Skey));
+    if (!EBIT_TEST(entry->Sflag, KEY_PRIVATE)) {
+	if (!cacheDigestTest(store_digest, entry->Skey)) {
 	    sd_stats.del_lost_count++;
 	    debug(71, 6) ("storeDigestDel: lost entry, key: %s url: %s\n",
-		storeKeyText(entry->key), storeUrl(entry));
+		storeKeyText(entry->Skey), storeUrl(entry));
 	} else {
 	    sd_stats.del_count++;
-	    cacheDigestDel(store_digest, entry->key);
+	    cacheDigestDel(store_digest, entry->Skey);
 	    debug(71, 6) ("storeDigestDel: deled entry, key: %s\n",
-		storeKeyText(entry->key));
+		storeKeyText(entry->Skey));
 	}
     }
 #endif
@@ -187,31 +187,31 @@
     /* add some stats! XXX */
 
     debug(71, 6) ("storeDigestAddable: checking entry, key: %s\n",
-	storeKeyText(e->key));
+	storeKeyText(e->Skey));
 
     /* check various entry flags (mimics storeCheckCachable XXX) */
-    if (!EBIT_TEST(e->flags, ENTRY_CACHABLE)) {
+    if (!EBIT_TEST(e->Sflag, ENTRY_CACHABLE)) {
 	debug(71, 6) ("storeDigestAddable: NO: not cachable\n");
 	return 0;
     }
-    if (EBIT_TEST(e->flags, KEY_PRIVATE)) {
+    if (EBIT_TEST(e->Sflag, KEY_PRIVATE)) {
 	debug(71, 6) ("storeDigestAddable: NO: private key\n");
 	return 0;
     }
-    if (EBIT_TEST(e->flags, ENTRY_NEGCACHED)) {
+    if (EBIT_TEST(e->Sflag, ENTRY_NEGCACHED)) {
 	debug(71, 6) ("storeDigestAddable: NO: negative cached\n");
 	return 0;
     }
-    if (EBIT_TEST(e->flags, RELEASE_REQUEST)) {
+    if (EBIT_TEST(e->Sflag, RELEASE_REQUEST)) {
 	debug(71, 6) ("storeDigestAddable: NO: release requested\n");
 	return 0;
     }
-    if (e->store_status == STORE_OK && EBIT_TEST(e->flags, ENTRY_BAD_LENGTH)) {
+    if (e->store_status == STORE_OK && EBIT_TEST(e->Sflag, ENTRY_BAD_LENGTH)) {
 	debug(71, 6) ("storeDigestAddable: NO: wrong content-length\n");
 	return 0;
     }
     /* do not digest huge objects */
-    if (e->swap_file_sz > Config.Store.maxObjectSize) {
+    if (e->Sswap_file_sz > Config.Store.maxObjectSize) {
 	debug(71, 6) ("storeDigestAddable: NO: too big\n");
 	return 0;
     }
@@ -235,14 +235,14 @@
 
     if (storeDigestAddable(entry)) {
 	sd_stats.add_count++;
-	if (cacheDigestTest(store_digest, entry->key))
+	if (cacheDigestTest(store_digest, entry->Skey))
 	    sd_stats.add_coll_count++;
-	cacheDigestAdd(store_digest, entry->key);
+	cacheDigestAdd(store_digest, entry->Skey);
 	debug(71, 6) ("storeDigestAdd: added entry, key: %s\n",
-	    storeKeyText(entry->key));
+	    storeKeyText(entry->Skey));
     } else {
 	sd_stats.rej_count++;
-	if (cacheDigestTest(store_digest, entry->key))
+	if (cacheDigestTest(store_digest, entry->Skey))
 	    sd_stats.rej_coll_count++;
     }
 }
@@ -341,7 +341,7 @@
     sd_state.rewrite_lock = e = storeCreateEntry(url, url, flags, METHOD_GET);
     assert(sd_state.rewrite_lock);
     cbdataAdd(sd_state.rewrite_lock, NULL, 0);
-    debug(71, 3) ("storeDigestRewrite: url: %s key: %s\n", url, storeKeyText(e->key));
+    debug(71, 3) ("storeDigestRewrite: url: %s key: %s\n", url, storeKeyText(e->Skey));
     e->mem_obj->request = requestLink(urlParse(METHOD_GET, url));
     /* wait for rebuild (if any) to finish */
     if (sd_state.rebuild_lock) {
@@ -359,7 +359,7 @@
     assert(sd_state.rewrite_lock);
     assert(!sd_state.rebuild_lock);
     sd_state.rewrite_offset = 0;
-    EBIT_SET(e->flags, ENTRY_SPECIAL);
+    EBIT_SET(e->Sflag, ENTRY_SPECIAL);
     /* setting public key will purge old digest entry if any */
     storeSetPublicKey(e);
     /* fake reply */
@@ -384,7 +384,7 @@
     storeComplete(e);
     storeTimestampsSet(e);
     debug(71, 2) ("storeDigestRewriteFinish: digest expires at %d (%+d)\n",
-	e->expires, e->expires - squid_curtime);
+	e->Sexpires, e->Sexpires - squid_curtime);
     /* is this the write order? @?@ */
     requestUnlink(e->mem_obj->request);
     e->mem_obj->request = NULL;
